<?php
/*
#########################################################
##############   openPlaG 1.02: graph.php   #############
#########################################################
#############   written by Juergen Kummer   #############
#########################################################
##############   published under GNU GPL   ##############
#########################################################
Original source: http://rechneronline.de/function-graphs/
#########################################################
Copyright (C) 2007 Juergen Kummer

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*
This file draws the image and displays it.
*/

// deny access on the generated image from external urls
// you do not need to do that, but I would recommend it
// please change the domain name to the one desired
/*
if($HTTP_REFERER!="http://allowed_domain.org/" && $HTTP_REFERER!="http://www.allowed_domain.org/")
	die();
*/

// output as png image
Header ("Content-type: image/png");

// initial values for the display
if (!$c) {
	$formula1='pow(x#2)';
	$col1=0;//color 1
	$term1=1;//show term 1
	$term2="";//don't show term 2
	$term3="";//don't show term 3
	$sint1=0;//integral, derivative or f(x) of funktion 1
	$sint2=0;//integral, derivative or f(x) of funktion 2
	$sint3=0;//integral, derivative or f(x) of funktion 3
	$width=500;//image width
	$height=500;//image height
	$rulex1=-5;//x left
	$ruley1=-5;//y bottom
	$rulex2=5;//x right
	$ruley2=5;//y top
	$intervalsx=10;//number of x-intervals
	$intervalsy=10;//number of y-intervals
	$gridx=20;//number of x reticule lines
	$gridy=20;//number of y reticule lines
	$linex=5;//length x dashes
	$liney=5;//length y dashes
	$mid=0;//gap at origin
	$deci=3;//decimal places
	$lines=1;//axis lines yes
	$grid=1;//reticule lines yes
	$numbers=1;//caption yes
	$dashes=1;//dashes yes
	$frame=1;//frame yes
	$errors=1;//show errors yes
	$logsk=0;//logarithmic scale no
}

// use constants as range
$rulex1=str_replace("pi",M_PI,$rulex1);
$rulex1=str_replace("e",M_E,$rulex1);
$rulex1=str_replace("sq2",M_SQRT2,$rulex1);
$rulex1=str_replace("go","1.6180339887499",$rulex1);
$rulex1=str_replace("d","4.669201609103",$rulex1);
$ruley1=str_replace("pi",M_PI,$ruley1);
$ruley1=str_replace("e",M_E,$ruley1);
$ruley1=str_replace("sq2",M_SQRT2,$ruley1);
$ruley1=str_replace("go","1.6180339887499",$ruley1);
$ruley1=str_replace("d","4.669201609103",$ruley1);
$rulex2=str_replace("pi",M_PI,$rulex2);
$rulex2=str_replace("e",M_E,$rulex2);
$rulex2=str_replace("sq2",M_SQRT2,$rulex2);
$rulex2=str_replace("go","1.6180339887499",$rulex2);
$rulex2=str_replace("d","4.669201609103",$rulex2);
$ruley2=str_replace("pi",M_PI,$ruley2);
$ruley2=str_replace("e",M_E,$ruley2);
$ruley2=str_replace("sq2",M_SQRT2,$ruley2);
$ruley2=str_replace("go","1.6180339887499",$ruley2);
$ruley2=str_replace("d","4.669201609103",$ruley2);
eval("\$rulex1 = $rulex1;");
eval("\$rulex2 = $rulex2;");
eval("\$ruley1 = $ruley1;");
eval("\$ruley2 = $ruley2;");

$sum=0; //addition variable for phi
$iter=""; //last value for iteration
$iter2=""; //one before last value for iteration
$istep=0; //counter for iteration steps
$overflow=0; //counter for overflows
$paint=1; //draw graph yes
$asyval[0]="";//values for asymptotes
$asyval[1]="";
$asyval[2]="";
$derval="";//start value for the derivative within a function, e.g. D(x)

// +C for integrals
$cint[0]=$cint1;
$cint[1]=$cint2;
$cint[2]=$cint3;
for($i=0;$i<3;$i++) {
	$cint[$i]=str_replace(",",".",$cint[$i]);
	$cint[$i]=str_replace("pi",M_PI,$cint[$i]);
	$cint[$i]=str_replace("e",M_E,$cint[$i]);
	$cint[$i]=str_replace("sq2",M_SQRT2,$cint[$i]);
	$cint[$i]=str_replace("go","1.6180339887499",$cint[$i]);
	$cint[$i]=str_replace("d","4.669201609103",$cint[$i]);
}

// read values
$form[0]=$formula1;//formula term 1 for display
$form[1]=$formula2;//formula term 2 for display
$form[2]=$formula3;//formula term 2 for display
$sint[0]=$sint1;//integral, derivative or f(x) of funktion 1
$sint[1]=$sint2;//integral, derivative or f(x) of funktion 2
$sint[2]=$sint3;//integral, derivative or f(x) of funktion 3
$col[0]=$col1;//color 1
$col[1]=$col2;//color 2
$col[2]=$col3;//color 3
$term[0]=$term1;//show term 1
$term[1]=$term2;//show term 2
$term[2]=$term3;//show term 3

// definition and result range
if(strlen(strval($ta1))==0) $ta1=-999999;
if(strlen(strval($ta2))==0) $ta2=999999;
if(strlen(strval($tb1))==0) $tb1=-999999;
if(strlen(strval($tb2))==0) $tb2=999999;
if(strlen(strval($tc1))==0) $tc1=-999999;
if(strlen(strval($tc2))==0) $tc2=999999;
$tdef1[0]=str_replace(",",".",$ta1);
$tdef1[1]=str_replace(",",".",$tb1);
$tdef1[2]=str_replace(",",".",$tc1);
$tdef2[0]=str_replace(",",".",$ta2);
$tdef2[1]=str_replace(",",".",$tb2);
$tdef2[2]=str_replace(",",".",$tc2);
for($i=0;$i<3;$i++) { //constants as range
	$tdef1[$i]=str_replace("pi",M_PI,$tdef1[$i]);
	$tdef1[$i]=str_replace("e",M_E,$tdef1[$i]);
	$tdef1[$i]=str_replace("sq2",M_SQRT2,$tdef1[$i]);
	$tdef1[$i]=str_replace("go","1.6180339887499",$tdef1[$i]);
	$tdef1[$i]=str_replace("d","4.669201609103",$tdef1[$i]);
	$tdef2[$i]=str_replace("pi",M_PI,$tdef2[$i]);
	$tdef2[$i]=str_replace("e",M_E,$tdef2[$i]);
	$tdef2[$i]=str_replace("sq2",M_SQRT2,$tdef2[$i]);
	$tdef2[$i]=str_replace("go","1.6180339887499",$tdef2[$i]);
	$tdef2[$i]=str_replace("d","4.669201609103",$tdef2[$i]);
	eval("\$tdef1[$i] = $tdef1[$i];");
	eval("\$tdef2[$i] = $tdef2[$i];");
}

// create empty image and define colors
$img=imagecreatetruecolor($width,$height);
imageantialias($img,TRUE);
$white=imagecolorallocate($img,255,255,255);
$grey=imagecolorallocate($img,190,190,190);
$black=imagecolorallocate($img,0,0,0);
$color[0]=imagecolorallocate($img,0,0,255);//blue
$color[1]=imagecolorallocate($img,255,0,0);//red
$color[2]=imagecolorallocate($img,0,255,0);//green
$color[3]=imagecolorallocate($img,127,127,127);//grey
$color[4]=imagecolorallocate($img,0,0,0);//black
imagefill ($img,0,0,$white);

$single=0; //we don't want to compute a single value, but the whole graph
include "init.php";

// start for axis lines:
$rulex=$rulex2-$rulex1;
$ruley=$ruley2-$ruley1;
$startx=round($height/$ruley*$ruley2);
$starty=round($width/$rulex*(-$rulex1));
if ($startx<0) $startx=0;
if ($startx>=$height) $startx=$height-1;
if ($starty<0) $starty=0;
if ($starty>=$width) $starty=$width-1;

// draw reticule lines
if($grid) {
	$stepx=intval($width/$gridx+.5);
	for($i=0;$i<=$stepx*$gridx ;$i+=$stepx) {
		if($i>0) { //reticule lines x
			if ($i==$starty+1 || $i==$starty-1)
				$i=$starty;
			imageline ($img,$i,0,$i,$height-1,$grey);
		}
	}
	$stepy=intval($height/$gridy+.5);
	for($i=0;$i<=$stepy*$gridy ;$i+=$stepy) {
		if ($i>0) { //reticule lines y
			if ($i==$startx+1 || $i==$startx-1)
				$i=$startx;
			imageline ($img,0,$i,$width-1,$i,$grey);
		}
	}
}

// caption x-axis
$count=-1;
$stepx=round($width/$intervalsx);
for($i=0;$i<=$stepx*$intervalsx ;$i+=$stepx) {
	$gap=0;
	++$count;
	if($dashes && $i>0) { //dashes x
		if ($i==$starty+1 || $i==$starty-1)
			$i=$starty;
		imageline ($img,$i,min($startx,$height)+$linex+1,$i,min($startx,$height)-$linex,$black);
	}
	$value=$rulex1+$count*$rulex/$intervalsx;
         $value=round($value,$deci);
	$gap+=strlen($value)*3;
	if ($value && $count && $i!=$stepx*$intervalsx) { //labels x
		if ($startx<$height/2)
			$align=15;
		else
			$align=-15;
		if ($numbers)
			imagestring ($img,3,$i-$gap,min($startx,$height)+$align-$linex,$value,$black);
	}
}
if($numbers)
	imagestring ($img,4,$width-15,min($startx,$height)+$align-$linex,"x",$black);

// caption y-axis
$count=0;
$stepy=round($height/$intervalsy);
for($i=$stepy;$i<=$stepy*$intervalsy ;$i+=$stepy) {
	++$count;
	if ($dashes && $i>0) { //dashes y
		if ($i==$startx+1 || $i==$startx-1)
			$i=$startx;
		imageline ($img,max($starty,0)+$liney+1,$i,max($starty,0)-$liney,$i,$black);
	}
	$value=$ruley2-$count*$ruley/$intervalsy;
	$gap+=strlen($value)*3;
	if ($value && $count && $i!=$stepy*$intervalsy) { //labels y
		if ($starty<=$width/2)
			$align=4;
		else
			$align=-30-strlen($value)*4;
		if(strval($logsk)=="M_E")
			$logsk=2.718281828459;
		if($logsk)
			$value=pow($logsk,$value);
		$value=round($value,$deci);
		$value=str_replace('E+','*10^',$value);
		if(substr($value,0,2)=="1*")
			$value=str_replace('1*','',$value);
		if ($numbers)
			imagestring ($img,3,max($starty,0)+$align+$liney,$i-6,$value,$black);
	}
}
if($numbers)
	imagestring ($img,4,max($starty,0)+$align+$liney,5,"y",$black);

// draw axis lines
if ($lines) {
	imageline ($img,0,$startx,$width-1,$startx,$black); //horizontally
	imageline ($img,$starty,0,$starty,$height-1,$black); //vertically
}

// draw asymptotes
if($asyval[0])
	imageline ($img,$asyval[0],0,$asyval[0],$height-1,$color[$col[0]]);
if($asyval[1])
	imageline ($img,$asyval[1],0,$asyval[1],$height-1,$color[$col[1]]);
if($asyval[2])
	imageline ($img,$asyval[2],0,$asyval[2],$height-1,$color[$col[2]]);

// draw gap at origin
if ($mid>0) {
	$middlex=-$rulex1/$rulex*$width;
	$middley=$ruley2/$ruley*$height;
	imagerectangle ($img,$middlex-$mid,$middley-$mid,$middlex+$mid,$middley+$mid,$black);
	--$mid;
	if ($mid>0)
		imagefilledrectangle ($img,$middlex-$mid,$middley-$mid,$middlex+$mid,$middley+$mid,$white);
}

// draw graph
$count=0;
$derivative=""; //remember old value for derivative
$valyold=""; //remember old value for derivative
$derval="";
for ($j=0;$j<3;$j++) {
	if ($formula[$j]!="" && $formula[$j]==str_replace("asy","",$formula[$j])) { //don't draw graph when function is asymptote
		$iter="";
		$iter2="";
		$istep=0;
		if(!$sint[$j] || !$logsk) {//no integral or derivative at a log scale
			$sum=0;
			$integral=0;
			$intplus=0; // +C at integral
			unset($x1);
			unset($y1);
			for ($i=0;$i<=$width;$i++) {
				$valx=$rulex1+$i*$rulex/$width;
				if($valx>=$tdef1[$j] && $valx<=$tdef2[$j]) { //draw over definition range
					$valy=graph($valx,$formula[$j]);
					if($sint[$j]==2 && is_numeric($valy)) {//integrate
						$integral+=$valy/$width*$rulex;
						$valy=$integral;
						if($cint[$j])
							$intplus=$cint[$j]*$width/$rulex;
					}
					else if($sint[$j]==1 && is_numeric($valy)) {//derivate
						$valyold=$valy;
						if(is_numeric($derivative)) {
							$valy-=$derivative;
							$valy*=$width/$rulex;
						}
						if(!is_numeric($derivative))
							$valy=NULL;
						$derivative=$valyold;
					}
					if ($valy==999999) {
						++$overflow;
						++$count;
						if($overflow>9) {
							if($errors)
								imagestring ($img,5,$height/2-80,100,$text2.($j+1),$color[$col[$j]]);
							break;
						}
					}
					$set1=$height-1-intval(($valy-$ruley1)/$ruley*$height-.5);
					$set2=$height-1-intval(($valy-$ruley1)/$ruley*$height+.5);
					$set=round(($set1+$set2)/2);
					if (strlen($valy)) {
						if (!isset($x1)) $x1=$i;
						if (!isset($y1)) $y1=$set;
						if(!(($y1>$height && $set<0) || ($y1<0 && $set>$height))) {
							if(abs($y1-$set)<$height/3) {//don't connect poles
								imageline($img,$x1,$y1-$intplus,$i,$set-$intplus,$color[$col[$j]]);//connect two dots
							}
						}
						$x1=$i;
						$y1=$set;
						++$count;
					} else { //don't connect definition gaps
						unset($x1);
						unset($y1);
					}
				}
			}
		}
		unset($sumres);
	} else
		++$count;
}

// error message at result overflows or when no result found
if(!$count && $errors){
	imagestring ($img,5,100,$height/2-100,$text3,$color[1]);
	imagestring ($img,5,100,$height/2-80,$text4,$color[1]);
}

// show term
for($i=0;$i<3;$i++) {
	if($form[$i]!=""){
		if ($sint[$i]==2) {
			$form[$i]="F(x)=S[".$form[$i]."]";
		if($cint[$i]>0)
			$form[$i].="+";
		if ($cint[$i])
			$form[$i].=$cint[$i];
		}
		else if ($sint[$i]==1)
			$form[$i]="f'(x)=[".$form[$i]."]'";
		else
			$form[$i]="f(x)=".$form[$i];
		if ($term[$i])
			imagestring ($img,5,10,15*($i+1)-10,$form[$i],$color[$col[$i]]);
	}
}

// draw frame
if ($frame)
	imagerectangle ($img,0,0,$width-1,$height-1,$black);

// make image
ImagePng($img);
?>